# kdeui Library API Documentation

Overview | Class Hierarchy | Classes | Classes (annotated) | Members | Namespaces | Source Files

# KListViewSearchLine Class Reference

This class makes it easy to add a search line for filtering the items in a listview based on a simple text search. More...

`#include <klistviewsearchline.h>`

Inheritance diagram for KListViewSearchLine:

[legend]
Collaboration diagram for KListViewSearchLine:

[legend]
List of all members.

## Public Slots

virtual void | updateSearch (const QString &s=QString::null)
void | setCaseSensitive (bool cs)
void | setKeepParentsVisible (bool v)
void | setSearchColumns (const QValueList< int > &columns)
void | setListView (KListView *lv)

## Public Member Functions

| KListViewSearchLine (QWidget *parent=0, KListView *listView=0, const char *name=0)
| KListViewSearchLine (QWidget *parent, const char *name)
virtual | ~KListViewSearchLine ()
bool | caseSensitive () const
QValueList< int > | searchColumns () const
bool | keepParentsVisible () const
KListView * | listView () const

## Protected Slots

void | queueSearch (const QString &search)
void | activateSearch ()

## Protected Member Functions

virtual bool | itemMatches (const QListViewItem *item, const QString &s) const
virtual QPopupMenu * | createPopupMenu ()

## Detailed Description

This class makes it easy to add a search line for filtering the items in a listview based on a simple text search.

No changes to the application other than instantiating this class with an appropriate KListView should be needed.

Since:
  3.3

Definition at line 39 of file klistviewsearchline.h.

## Constructor & Destructor Documentation

KListViewSearchLine::KListViewSearchLine | ( | QWidget * | parent = `0`,
|  | KListView * | listView = `0`,
|  | const char * | name = `0`
| ) |

| Constructs a KListViewSearchLine with listView being the KListView to be filtered. If listView is null then the widget will be disabled until a listview is set with setListView(). Definition at line 59 of file klistviewsearchline.cpp. References listView(), queueSearch(), and QLineEdit::textChanged().

KListViewSearchLine::KListViewSearchLine | ( | QWidget * | parent,
|  | const char * | name
| ) |

| Constructs a KListViewSearchLine without any KListView to filter. The KListView object has to be set later with setListView(). Definition at line 80 of file klistviewsearchline.cpp. References queueSearch(), and QLineEdit::textChanged().

KListViewSearchLine::~KListViewSearchLine | ( |  | ) | `[virtual]`

| Destroys the KListViewSearchLine. Definition at line 93 of file klistviewsearchline.cpp.

## Member Function Documentation

bool KListViewSearchLine::caseSensitive | ( |  | ) | const

Returns true if the search is case sensitive.

This defaults to false.

See also:
  setCaseSensitive()

Definition at line 98 of file klistviewsearchline.cpp.

QValueList< int > KListViewSearchLine::searchColumns | ( |  | ) | const

Returns the current list of columns that will be searched.

If the returned list is empty all visible columns will be searched.

See also:
  setSearchColumns

Definition at line 103 of file klistviewsearchline.cpp.

bool KListViewSearchLine::keepParentsVisible | ( |  | ) | const

If this is true (the default) then the parents of matched items will also be shown.

See also:
  setKeepParentsVisible()

Definition at line 108 of file klistviewsearchline.cpp.

KListView * KListViewSearchLine::listView | ( |  | ) | const

Returns the listview that is currently filtered by the search.

See also:
  setListView()

Definition at line 113 of file klistviewsearchline.cpp.

Referenced by KListViewSearchLine().

void KListViewSearchLine::updateSearch | ( | const QString & | s = `QString::null` | ) | `[virtual, slot]`

| Updates search to only make visible the items that match s. If s is null then the line edit's text will be used. Definition at line 122 of file klistviewsearchline.cpp. References QListViewItem::listView(), and QLineEdit::text(). Referenced by activateSearch().

void KListViewSearchLine::setCaseSensitive | ( | bool | cs | ) | `[slot]`

Make the search case sensitive or case insensitive.

See also:
  caseSenstive()

Definition at line 163 of file klistviewsearchline.cpp.

void KListViewSearchLine::setKeepParentsVisible | ( | bool | v | ) | `[slot]`

When a search is active on a list that's organized into a tree view if a parent or ancesestor of an item is does not match the search then it will be hidden and as such so too will any children that match.

If this is set to true (the default) then the parents of matching items will be shown.

See also:
  keepParentsVisible

Definition at line 168 of file klistviewsearchline.cpp.

void KListViewSearchLine::setSearchColumns | ( | const QValueList< int > & | columns | ) | `[slot]`

Sets the list of columns to be searched.

The default is to search all, visible columns which can be restored by passing columns as an empty list.

See also:
  searchColumns

Definition at line 173 of file klistviewsearchline.cpp.

void KListViewSearchLine::setListView | ( | KListView * | lv | ) | `[slot]`

Sets the KListView that is filtered by this search line.

If lv is null then the widget will be disabled.

See also:
  listView()

Definition at line 178 of file klistviewsearchline.cpp.

References QListViewItem::listView().

bool KListViewSearchLine::itemMatches | ( | const QListViewItem * | item,
|  | const QString & | s
| ) | const`[protected, virtual]`

| Returns true if item matches the search s. This will be evaluated based on the value of caseSensitive(). This can be overridden in subclasses to implement more complicated matching schemes. Definition at line 205 of file klistviewsearchline.cpp. References QValueList::end(), and QValueList::find().

QPopupMenu * KListViewSearchLine::createPopupMenu | ( |  | ) | `[protected, virtual]`

Re-implemented for internal reasons.

API not affected.

See QLineEdit::mousePressEvent().

Reimplemented from KLineEdit.

Definition at line 234 of file klistviewsearchline.cpp.

References QString::arg(), QPopupMenu::clear(), KLineEdit::createPopupMenu(), QPopupMenu::insertItem(), QPopupMenu::insertSeparator(), QString::isEmpty(), QHeader::mapToIndex(), QHeader::mapToSection(), and QPopupMenu::setItemChecked().

void KListViewSearchLine::queueSearch | ( | const QString & | search | ) | `[protected, slot]`

When keys are pressed a new search string is created and a timer is activated.

The most recent search is activated when this timer runs out if another key has not yet been pressed.

This method makes

Parameters:

  | search | the most recent search and starts the timer.

Together with activateSearch() this makes it such that searches are not started until there is a short break in the users typing.

See also:
  activateSearch()

Definition at line 284 of file klistviewsearchline.cpp.

References activateSearch(), and QTimer::singleShot().

Referenced by KListViewSearchLine().

void KListViewSearchLine::activateSearch | ( |  | ) | `[protected, slot]`

When the timer started with queueSearch() expires this slot is called.

If there has been another timer started then this slot does nothing. However if there are no other pending searches this starts the list view search.

See also:
  queueSearch()

Definition at line 291 of file klistviewsearchline.cpp.

References updateSearch().

Referenced by queueSearch().

The documentation for this class was generated from the following files:

- klistviewsearchline.h
- klistviewsearchline.cpp

This file is part of the documentation for kdeui Library Version 3.4.1.
Documentation copyright © 1996-2004 the KDE developers.
Generated on Sat Jun 11 20:21:36 2005 by doxygen 1.4.1 written by Dimitri van Heesch, © 1997-2003